﻿Type=Service
Version=2.71
@EndOfDesignText@
#Region Module Attributes
	#StartAtBoot: false
#End Region

'Service module
Sub Process_Globals
	'These global variables will be declared once when the application starts.
	'These variables can be accessed from all modules.
		
	Private mp As MediaPlayer     ' You need to declare mp as Mediaplayer

	Private rm As RingtoneManager
	Private phw As PhoneWakeState	' don't use this if not necessary - Drain the battery if not properly managed
	'http://developer.android.com/reference/android/os/PowerManager.html
	Private ph As Phone
	Private PhVol As Int
		
	Private TimerDuration As Timer
	Private TimerDurationCount As Int
	Private TimerCrescendo As Timer
	Private TimerCrescendoCount As Int
	
	Private MaxVolume As Int 			' in percent
	Private Time2MaxVolume As Int
	Private Volume As Float
	
	Dim SnoozeCount As Int = 0		' don't declare in main???
	
	Private TTS1 As TTS
End Sub

Sub Service_Create
	
End Sub

Sub Service_Start

	DoEvents
	
	StartActivity("RingAction")	
	
'	mp.Initialize2("MP")  	'Initialize Mediaplayer
	mp.Initialize  			'Initialize Mediaplayer
	PlayAlarm
	
	'ToastMessageShow("Hey!!!! Wake up!!!", True)
		
End Sub

Sub Service_Destroy

	mp.Stop
	MP_Complete
	TTS1.Release
	
	' goToSleep
	phw.ReleaseKeepAlive	' don't forget!
	
'	StopService("")     'Stop this service
'	CancelScheduledService("")   'Cancel this service
	
End Sub

Sub PlayAlarm
	
	' This is only needed when the application is killed
	If Not(TimeManager.ListSchedule.IsInitialized) Then
		CallSub(TimeManager,"PrepareData")
		CallSub(TimeManager,"Recalldata")
	End If
		
	Dim MaxVol As Float
  	PhVol = ph.GetVolume(ph.VOLUME_MUSIC)		'get current music channel volume
   	MaxVol = ph.GetMaxVolume(ph.VOLUME_MUSIC)	'get max music channel volume
   	ph.SetVolume(ph.VOLUME_MUSIC,MaxVol,False)  'set phone music channel to max volume

	If TimeManager.SoundType <> "SILENT" Then
		If TimeManager.Snoozes > 0 AND SnoozeCount = TimeManager.Snoozes Then
			MaxVolume = 100
			mp.Load(File.DirAssets, "sound0.mp3")
		Else
			If TimeManager.AlarmSound = "" Then
				mp.Load(File.DirAssets, "sound1.mp3")	
			Else
				Try
					If TimeManager.SoundType = "Ringtone" Then
						'Log("Ringtone")
						' Can not check using:
						' If File.Exists(rm.GetContentDir, AlarmSound) 
						' Uri is not a real file.
						' http://www.basic4ppc.com/forum/basic4android-updates-questions/29467-how-check-If-uri-Ringtone-exists.html 
						Try
							mp.Load(rm.GetContentDir, TimeManager.AlarmSound)
						Catch
							mp.Load(File.DirAssets, "sound1.mp3")	' prevent alarm does not sound due to error	of the ringtone
							ToastMessageShow("Ringtone " & TimeManager.AlarmSound & " not found",True)
						End Try
					Else
						If File.Exists(Main.DirMusic, TimeManager.AlarmSound) Then
							mp.Load(Main.DirMusic, TimeManager.AlarmSound)
						Else
							mp.Load(File.DirAssets, "sound1.mp3")	' prevent alarm does not sound due to error	
							ToastMessageShow("Music file " & TimeManager.AlarmSound & " not found",True)
						End If
					End If
				Catch
					' Do not user Msgbox in service
					ToastMessageShow("Error in loading the ringtone/sound",True)
				End Try
			End If
		End If	

		mp.Looping = True
		MaxVolume = TimeManager.MaxVolume 
		
		mp.SetVolume(0,0)
		Time2MaxVolume = TimeManager.TimeMaxVolume * 1000 	
		TimerCrescendoCount = 0
		TimerCrescendo.Initialize("TimerCrescendo",100)
		TimerCrescendo.Enabled = True

		' mp.SetVolume(MaxVolume,MaxVolume)
		
		TimerDurationCount = 0
		TimerDuration.Initialize("TimerDuration",100)
		TimerDuration.Enabled = True
		
		mp.Play
	
	Else
	
		TimerDurationCount = 0
		TimerDuration.Initialize("TimerDuration",100)
		TimerDuration.Enabled = True
		
	End If
	
	If TimeManager.Vibrate > 0 Then
		' Not available on Tabs???
		Vibrate(500, TimeManager.Vibrate)
	End If
	
	'Log("IsScreenOn:" & IsScreenOn)
	If Not(IsScreenOn) Then
		phw.KeepAlive(True)
	End If
		
End Sub

Sub TimerCrescendo_tick
	TimerCrescendoCount = TimerCrescendoCount + 1
'	Log("TimerCrescendoCount: " & TimerCrescendoCount)
	Volume = ((TimerCrescendoCount*TimerCrescendo.Interval)/Time2MaxVolume) * (MaxVolume/100)
	'Log("Volume: " & Volume)
	If Volume > MaxVolume/100 Then
		If TimeManager.Snoozes > 0 AND SnoozeCount = TimeManager.Snoozes Then
			If TTS1.IsInitialized = False Then
		        TTS1.Initialize("TTS1")
				TTS1.SpeechRate = .1
				TTS1.Pitch = 1.5
'				Log("tts")
		    End If
		End If
		TimerCrescendo.Enabled = False
		Volume = MaxVolume
	End If
	mp.SetVolume(Volume, Volume)
	
	' DoEvents not necessary???
	If (TimerCrescendoCount Mod 30) = 0 Then 
		DoEvents	' don't to much DoEvents in a loop -> freeze???
	End If
	
End Sub

Sub TimerDuration_tick
	TimerDurationCount = TimerDurationCount + 1
	'Log("TimerDurationCount: " & TimerDurationCount)
		
	If TimerDurationCount * TimerDuration.Interval > TimeManager.SoundDuration * 1000 Then
		' Snooze
		If IsPaused(RingAction) Then
			Log("RingAction paused")
		End If	
			
		'CallSubDelayed(RingAction,"btnSnooze_Click")	' still failed
		CallSubDelayed("","btnSnooze_click")
	End If
	
	'DoEvents		' don't to much DoEvents in a loop -> freeze???
	
End Sub

#Region  from btnClick in RingAction 

Sub btnDismis_Click
	TimeManager.noti.Cancel(1)
	CallSubDelayed("","Service_Destroy")
	TimerDuration.Enabled = False
	TimerCrescendo.Enabled = False
	
	' set for the next alarm
	SnoozeCount = 0
	CancelVibrate
	CallSubDelayed(TimeManager,"Select_Next") 
	
End Sub

Sub btnSnooze_Click
	'Log("snooze click")
	TimeManager.noti.Cancel(1)
	CallSubDelayed("","Service_Destroy")
	TimerDuration.Enabled = False
	TimerCrescendo.Enabled = False	' to prevent if the setting of the timer crecendo > duration
	
	MaxVolume = MaxVolume + 10	' Add 10% at next alarm
	
	DoEvents

	SnoozeCount = SnoozeCount + 1
	If SnoozeCount <= TimeManager.Snoozes Then
		TimeManager.DateTimeTicks = TimeManager.DateTimeTicks + TimeManager.TimeBetweenSnoozes * 1000
		CancelVibrate
		CallSubDelayed(TimeManager,"CompareSnoozeWithSchedule")
	Else
		btnDismis_Click
	End If
End Sub

#End Region 

#Region  Vibrate 

Sub Vibrate(On As Long, Off As Long)
    Dim r As Reflector
    r.Target = r.GetContext
    r.Target = r.RunMethod2("getSystemService", "vibrator", "java.lang.String")
    Dim pattern(2) As Long
    pattern(0) = On
    pattern(1) = Off
    r.RunMethod4("vibrate", Array As Object(pattern, 0), Array As String("[J", "java.lang.int"))
End Sub

Sub CancelVibrate
    Dim r As Reflector
    r.Target = r.GetContext
    r.Target = r.RunMethod2("getSystemService", "vibrator", "java.lang.String")
    r.RunMethod("cancel")
End Sub

#End Region

#Region  Power Manager 

Sub IsScreenOn As Boolean

    Dim r As Reflector
    r.Target = r.GetContext
    r.Target = r.RunMethod2("getSystemService", "power", "java.lang.String")
    Return r.RunMethod("isScreenOn")
	
End Sub

'Sub goToSleep
'	' still error - should have admin right???
' 	Dim r As Reflector
'    r.Target = r.GetContext
'	r.Target = r.RunMethod2("getSystemService", "power", "java.lang.String")
'	r.RunMethod("goToSleep") ', DateTime.Date(DateTime.Now), "java.lang.String")
'	
'End Sub

#End Region

Sub MP_Complete
'	Log("MP_Complete")
	ph.SetVolume(ph.VOLUME_MUSIC,PhVol,False)     
End Sub

Sub TTS1_Ready (Success As Boolean)
    If Success Then
		'Log("TTS1_Ready")
		Dim strText As String = TimeManager.notes
		Dim intPos As Int = strText.IndexOf(CRLF)	' check for multilines text
		If intPos <> -1 Then
			strText = strText.SubString2(0,intPos)	' only the first line
		End If
       	TTS1.Speak(strText & CRLF & CRLF & "Last Reminder", True)
		DoEvents
     Else
        Msgbox("Error initializing TTS engine.", "")
    End If
End Sub