﻿Type=Class
Version=2.71
@EndOfDesignText@
'AnotherDatePicker - v1.00
'
' Modified by Barx
'
'Class module
Sub Class_Globals
	Private holder As Panel
	Private cvs, cvsBackground As Canvas
	Private Base, topPanel, DaysPanel, pnlButtons As Panel
	Private month, year As Int
	Private Months As Spinner
	Private Years As Spinner
	Private boxW, boxH As Float
	Private vCorrection As Float
	Private ACTION_UP = 1, ACTION_MOVE = 2, ACTION_DOWN = 0 As Int
	Private tempSelectedDay As Int
	Private DaysPanelBackground As Panel
	Private dayOfWeekOffset As Int
	Private daysInMonth As Int
	Private tempSelectedColor As Int = Colors.Cyan
	Private selectedColor As Int = Colors.RGB(51, 181, 229)
	Private topPanelColor As Int = Colors.RGB(51, 181, 229)
	Private BasePanelColor As Int = Colors.RGB(248, 248, 255)
	Private lblSelectedDay As Label
	Private selectedDate As Long
	Private selectedYear, selectedMonth, selectedDay As Int
	Private Label1 As Label
	Private Label2 As Label
	Private Label3 As Label
	Private Label4 As Label
	Private Label5 As Label
	Private Label6 As Label
	Private Label7 As Label
	Private daysNames() As Label
	
	Private DateInit As Long
	Private blnBeginOnSunday As Boolean = True
	Private intYearStart As Int = 1900
	Private intYearEnd As Int = 2020
	
	Private mTarget As Object
	Private mEventName As String
End Sub

'Initializes the picker
Public Sub Initialize (Target As Object, EventName As String)
	mTarget = Target
	mEventName = EventName
	
	If SubExists(mTarget, mEventName & "_Closed") = False Then
		ToastMessageShow("There is no " & mEventName & "_Closed", False)
		Return
	End If
	
End Sub

'Adds the picker to its parent. ACT can be either an activity or a panel.
'Lbl is an existing label.
Public Sub AddView(ACT As Activity)
	'a gradient effect for the buttons at bottom of datepicker-----------------------
	Dim gd As GradientDrawable
	gd.Initialize("LEFT_RIGHT", Array As Int(Colors.White, Colors.Gray, Colors.White))
	'---------------------------------------------------------------------------------
	holder.Initialize("holder")
	Hide_holder
	'holder.Color = Colors.ARGB(255, 0, 0, 0)
	ACT.AddView(holder, 0, 0, 100%x, 100%y)
	holder.LoadLayout("DatePicker")
	
	topPanel.Color = topPanelColor
	Base.Color = BasePanelColor
	pnlButtons.Background = gd 'Apply gradient effect
	daysNames = Array As Label(Label1, Label2, Label3, Label4, Label5, Label6, Label7)
	
	cvs.Initialize(DaysPanel)
	cvsBackground.Initialize(DaysPanelBackground)
	month = DateTime.GetMonth(DateTime.Now)
	year = DateTime.GetYear(DateTime.Now)
	For y = intYearStart To intYearEnd
		Years.Add(y)
	Next
	For Each m As String In DateUtils.GetMonthsNames
		Months.Add(m)
	Next
	Dim i As Int
	' American - start on Sunday - original
	For Each d As String In DateUtils.GetDaysNames
		daysNames(i).Text = d.SubString2(0, 2)
		i = i + 1
	Next
	If Not(blnBeginOnSunday) Then
		' Euro - start on Monday -> shift	
		Dim Sunday As String = daysNames(0).text 
		For i = 0 To 5
			daysNames(i).text = daysNames(i+1).text
		Next
		daysNames(6).text = Sunday
	End If
	
	If DateInit = 0 Then
		setDate(DateTime.Now)
	End If 
	
	vCorrection = cvs.MeasureStringHeight("1", Typeface.DEFAULT_BOLD, Label1.TextSize) / 2
	boxW = cvs.Bitmap.Width / 7
	boxH = cvs.Bitmap.Height / 6
	lblSelectedDay.Visible = False
	DrawDays
	
End Sub

#Region  Property 

' Sets Starting Year
Public Sub setStartingYear(StarYear As Int)
	intYearStart = StarYear
End Sub

' Sets Ending Year
Public Sub setEndingYear(EndYear As Int)
	intYearEnd = EndYear
End Sub

' Sets Start of Week
Public Sub setBeginOnSunday(Sunday As Boolean)
	' Name of Property must not the same as variable
	blnBeginOnSunday = Sunday
End Sub

' Sets the Panel Color
Public Sub setPanelColor(color As Int)
	BasePanelColor = color
End Sub

' Sets or Gets the Date
Public Sub setDate(Date As Long)
	DateInit = Date
	year = DateTime.GetYear(DateInit)
	month = DateTime.GetMonth(DateInit)
	SelectDay(DateTime.GetDayOfMonth(DateInit))
	Years.SelectedIndex = year - intYearStart 
	Months.SelectedIndex = month - 1
End Sub

Public Sub getDate As Long
	'Log(DateTime.Date(selectedDate))
	Return selectedDate
End Sub

#End Region 

Private Sub DrawBox(c As Canvas, clr As Int, x As Int, y As Int)
	Dim r As Rect
	r.Initialize(x * boxW, y * boxH, (x + 1) * boxW, (y + 1) * boxH)
	c.DrawRect(r, clr, True, 0)
End Sub

Private Sub DrawDays
	'Log("DrawDays")
	cvsBackground.DrawColor(Colors.Transparent)
	cvs.DrawColor(Colors.Transparent)
	Dim firstDay As Long = DateUtils.setDate(year, month, 1) - 1
	daysInMonth = DateUtils.NumberOfDaysInMonth(month, year)
	
	If blnBeginOnSunday Then
		' Week start on Sunday - American - original
		' dayOfWeekOffset = DateTime.GetDayOfWeek(firstDay) Mod 7	
	Else
		' Week start on Monday - Euro? - modified
		dayOfWeekOffset = (DateTime.GetDayOfWeek(firstDay) - 1) Mod 7	
	End If
	
	If year = selectedYear AND month = selectedMonth Then
		'draw the selected box
		DrawBox(cvs, selectedColor, (selectedDay - 1 + dayOfWeekOffset) Mod 7, _
			(selectedDay - 1 + dayOfWeekOffset) / 7)
	End If
	For day = 1 To daysInMonth
		Dim row As Int = (day - 1 + dayOfWeekOffset) / 7
		cvs.DrawText(day, (((dayOfWeekOffset + day - 1) Mod 7) + 0.5) * boxW, _
			(row + 0.5)* boxH + vCorrection, Typeface.DEFAULT_BOLD, Label1.TextSize, Colors.Black, "CENTER")
	Next
	
	DaysPanel.Invalidate
End Sub

Private Sub SelectDay(day As Int)
	selectedDate = DateUtils.setDate(year, month, day)
	selectedDay = day
	selectedMonth = month
	selectedYear = year
End Sub

Private Sub DaysPanel_Touch (ACTION As Int, X As Float, Y As Float)
	Dim boxX = X / boxW, boxY = Y / boxH As Int
	Dim newSelectedDay As Int = boxY * 7 + boxX + 1 - dayOfWeekOffset
	Dim validDay As Boolean = newSelectedDay > 0 AND newSelectedDay <= daysInMonth
	If ACTION = ACTION_DOWN OR ACTION = ACTION_MOVE Then
		If newSelectedDay = tempSelectedDay Then Return
		cvsBackground.DrawColor(Colors.Transparent) 'clear background
		tempSelectedDay = newSelectedDay
		If validDay Then
			DrawBox(cvsBackground, tempSelectedColor, boxX, boxY)
			lblSelectedDay.Text = newSelectedDay
			lblSelectedDay.Visible = True
		Else
			lblSelectedDay.Visible = False
		End If
	Else If ACTION = ACTION_UP Then
		lblSelectedDay.Visible = False
		cvsBackground.DrawColor(Colors.Transparent)
		If validDay Then
			SelectDay(newSelectedDay)
			CallSub3(mTarget, mEventName & "_Closed", False, getDate)
			holder.RemoveView
		End If
	End If
	DaysPanelBackground.Invalidate
End Sub

Public Sub IsVisible As Boolean
	Return holder.Visible
End Sub

'Hide_holders the picker.
Public Sub Hide_holder
	holder.Visible = False
End Sub

'Shows the picker.
Public Sub Show()
	holder.Visible = True
	DrawDays
End Sub

Private Sub btnToday_Click
	setDate(DateTime.Now)
	CallSub3(mTarget, mEventName & "_Closed", False, getDate)
	holder.RemoveView
End Sub

Private Sub btnCancel_Click
	CallSub3(mTarget, mEventName & "_Closed", True, getDate)
	holder.RemoveView
End Sub

Private Sub Months_ItemClick (Position As Int, Value As Object)
	month = Position + 1
	DrawDays
End Sub

Private Sub Years_ItemClick (Position As Int, Value As Object)
	year = Value
	DrawDays
End Sub

Private Sub holder_Click
	'Uncomment the line below to allow hiding of the datepicker when the background is tapped
	'Hide_holder
End Sub
