﻿Type=Class
Version=2.71
@EndOfDesignText@
'Class module ClsWheel version 1.4
'Written by Klaus CHRISTL (klaus)
'V1.0		2012.12.14
'V1.1		2012.12.15	Amended some bugs.
'V1.2		2013.05.28	Amended a bug.
'V1.3		2013.06.12	Mofied property routines.
'						Added Show2 for raising an event when clicking the OK button
'						Added optional continus scrolling 
'V1.4		2013.06.14	Modified event from OK to Closed
'						Amended the sceen color problem
'
' Customized to make it more compact
' For date use AnotherDatePicker class

Sub Class_Globals
	Public WheelType As Int
	Public TIME_HM As Int = 1			
	Public VALUE1 As Int = 2		
	Public CUSTOM As Int = 5
	
	Private holder, pnlButtons As Panel
	Private pnlMain, pnlBackGround, pnlTop, pnlMiddle, pnlBottom As Panel
	Dim btnOK, btnCancel As Button
	Private lblTitle As Label
'	Private Callback As Object
'	Private CallbackView As Object
	Private scvWheel() As ScrollView
	Private objWheel() As Reflector
	Private cvsParent, cvsTop, cvsBottom As Canvas
	Private cVerticalScrollBar = False As Boolean
	Private Title As String
'	Private EventEnabled As Boolean
	
	Private ColWidths() As Int
	Private TotalColWidths() As Int
	Private WheelNb As Int		
	Private FontSize As Float
	Private lblHeight, WheelTop, btnHeight, btnWidth, pnlMainWidth, pnlMainHeight As Int
	Private pnlBackGroundHeight, pnlBackGroundOffset, btnSpace As Int
	Public Left As Int
	Public Top As Int
	Public Width As Int
	Public Height As Int
	
	Private TimerWheel As Timer
	
	Private WheelContent() As List
	Private WheelContentNb() As Int
	Private WheelContinus = 0 As Int
	
	Private ItemNb As Int = 5										
	Private ItemNb_2 As Int		
		ItemNb_2 = Floor(ItemNb / 2)
	Private lineWidth As Int = 4dip							
	Private colBackGround As Int = Colors.Blue	
	Private colShadow As Int = Colors.Black			
	Private colWindowLine As Int = Colors.Red		
	Private colWindow As Int = Colors.ARGB(96, 255, 0, 0)	
'	Private colScreen As Int = Colors.ARGB(196, 0, 0, 0) 
	Private ScrollPos() As Int 
	Private y1 As Int 
	Private t1 As Long
	Private speed As Double
'	Private CurrentDayIndex As Int
	Private CurrentScrollView As ScrollView
'	Dim SepText As String = " "			
	
	Private mTarget As Object
	Private mEventName As String
	
End Sub

'Initialize the Wheel.
'CallbackModule = calling module mostly Me
'Parent = parent view Activity
'cTitle = title for the wheels, enter "" and empty string for no title
'cWheelNb = number of wheels
'cWheelContent0() = array of Lists with the content for each wheel
'cFontSize = text size for all wheels and the title
'cWheelType = 0 DATE	1 = TIME_HM  2 = TIME_HMS  3 = DATE_TIME  4 = CUSTOM 
'max number of custom wheels 5
'cContinusScrolling = True continus scrolling
'Example:
'<code>Dim DateWheel As ClsWheel
'DateWheel.Initialize (Me, Activity, "DateWheel", "Enter the date", 10dip, 10dip, 3, Null, 16, 0)</code>
Public Sub Initialize (Target As Object, EventName As String)
	mTarget = Target
	mEventName = EventName
	
	If SubExists(mTarget, mEventName & "_Closed") = False Then
		ToastMessageShow("There is no " & mEventName & "_Closed", False)
		Return
	End If
	
End Sub

Public Sub AddView(Parent As Activity, cTitle As String, cWheelNb As Int, cFontSize As Float, cWheelType As Int)
	
	holder.Initialize("holder")
	Hide_holder
	holder.Color = Colors.ARGB(102, 0, 0, 0)
	Parent.AddView(holder, 0, 0, 100%x, 100%y)
	
	Dim gd As GradientDrawable
	gd.Initialize("LEFT_RIGHT", Array As Int(Colors.White, Colors.Gray, Colors.White))
	
	Title = cTitle
	WheelNb = cWheelNb
	FontSize = cFontSize
	WheelType = cWheelType
	
	Dim cContinusScrolling As Boolean = False
	If cContinusScrolling = False Then
		WheelContinus = 0
	Else
		WheelContinus = 2
	End If
	
	btnSpace = 1dip	
	btnHeight = 50dip
'	btnWidth = Width/2-btnSpace
	
	Select WheelType
		Case TIME_HM
			InitializeTime_HM
		Case VALUE1
			InitializeValue1
		Case CUSTOM
			InitializeCustom
	End Select
	
	TimerWheel.Initialize("TimerWheel", 200)
		
	pnlMainWidth = 10000
	pnlMainHeight = 10000
	Do Until pnlMainWidth <= 100%x AND pnlMainHeight <= 100%y
		cvsParent.Initialize(Parent)
		lblHeight = cvsParent.MeasureStringHeight("Ag", Typeface.DEFAULT, FontSize) + DipToCurrent(FontSize / 2)

		pnlBackGroundHeight = ItemNb * lblHeight 
'		If Title = "" Then
'			pnlMainHeight = pnlBackGroundHeight + btnHeight + 2 * btnSpace
'			WheelTop = 0
'		Else
'			pnlMainHeight = pnlBackGroundHeight + btnHeight + 2 * btnSpace + lblHeight
'			WheelTop = lblHeight
'		End If
		If Title = "" Then
			pnlMainHeight = pnlBackGroundHeight + btnHeight + 2 * btnSpace + 10dip
			WheelTop = 5dip
		Else
			pnlMainHeight = pnlBackGroundHeight + btnHeight + 2 * btnSpace + lblHeight + 10dip
			WheelTop = lblHeight + 5dip
		End If
		Dim ColWidths(WheelNb) As Int
		Dim TotalColWidths(WheelNb + 1) As Int
		Dim i, j As Int
		TotalColWidths(0) = lineWidth 
		For i = 0 To WheelNb - 1
			ColWidths(i) = 0
			For j = 0 To WheelContent(i).Size -1
				ColWidths(i) = Max(ColWidths(i), cvsParent.MeasureStringWidth(WheelContent(i).get(j), Typeface.DEFAULT, FontSize))
			Next 
			ColWidths(i) = ColWidths(i) + 30dip		' ori 20dip
			TotalColWidths(i + 1) = TotalColWidths(i) + ColWidths(i) + lineWidth
		Next
		
		pnlMainWidth = Max(2 * btnWidth + 4 * btnSpace, cvsParent.MeasureStringWidth(Title, Typeface.DEFAULT, FontSize))
		If pnlMainWidth > TotalColWidths(WheelNb) Then
			pnlBackGroundOffset = (pnlMainWidth - TotalColWidths(WheelNb)) / 2
		Else
			pnlMainWidth = TotalColWidths(WheelNb)
			pnlBackGroundOffset = 0
		End If
		
		If pnlMainWidth > 100%x Then
			FontSize = Floor(FontSize * 100%x / pnlMainWidth)
		End If
		
		If pnlMainHeight > 100%y Then
			FontSize = Floor(FontSize * (100%y - btnHeight - 2 * btnSpace) / (pnlMainHeight - btnHeight - 2 * btnSpace))
		End If
	Loop

	Left = 50%x - pnlMainWidth / 2
	Top = 50%y - pnlMainHeight / 2
	
	pnlMain.Initialize("pnlMain")
	holder.AddView(pnlMain, Left, Top, pnlMainWidth, pnlMainHeight)
	pnlMain.Color = Colors.RGB(248, 248, 255)		' ori Colors.Black

	btnWidth = pnlMain.Width/2-btnSpace

	pnlButtons.Initialize("")
	pnlButtons.Background = gd
	pnlMain.AddView(pnlButtons, 0, pnlMain.Height - btnHeight, pnlMain.Width, btnHeight)
	
	btnOK.Initialize("btnOK")
	btnOK.Text = "O K"
	btnOK.color = Colors.RGB(248, 248, 255)
	btnOK.TextSize = Main.TextSizeStd0 * .9
	pnlButtons.AddView(btnOK, pnlButtons.Width - btnWidth, 2dip, btnWidth, btnHeight-2dip)

	btnCancel.Initialize("btnCancel")
	btnCancel.Text = "Cancel"
	btnCancel.color = Colors.RGB(248, 248, 255)
	btnCancel.TextSize = Main.TextSizeStd0 * .9
	pnlButtons.AddView(btnCancel, 0, 2dip, btnWidth, btnHeight-2dip)

	pnlBackGround.Initialize("pnlBackGround")
	pnlBackGround.Color = colBackGround
	pnlMain.AddView(pnlBackGround, pnlBackGroundOffset, WheelTop, TotalColWidths(WheelNb), pnlBackGroundHeight)
	
	If Title <> "" Then
		lblTitle.Initialize("")
		pnlMain.AddView(lblTitle, 0, 0, pnlMainWidth, lblHeight)
		lblTitle.Color = Colors.RGB(51, 181, 229)  ' ori colShadow
		lblTitle.TextSize = FontSize * .6			'ori FontSize	
		lblTitle.TextColor = Colors.Black
		lblTitle.Gravity = Bit.OR(Gravity.CENTER_HORIZONTAL, Gravity.CENTER_VERTICAL)
'		lblTitle.Gravity = Bit.OR(Gravity.CENTER_HORIZONTAL, Gravity.BOTTOM)
		lblTitle.Text = Title
	End If
	pnlBackGround.Color = colBackGround
	
	Dim scvWheel(WheelNb) As ScrollView
	Dim objWheel(WheelNb) As Reflector
'	Dim cvsWheel As Canvas
'	Dim x1, x2, y2 As Float
	For i = 0 To WheelNb - 1
		scvWheel(i).Initialize2(lblHeight * (WheelContent(i).Size + ItemNb - 1), "scv")
		pnlBackGround.AddView(scvWheel(i), TotalColWidths(i), 0, ColWidths(i), pnlBackGroundHeight)
		scvWheel(i).Tag = i
		objWheel(i).Target = scvWheel(i)
		
		scvWheel(i).Panel.Color = Colors.White
		
		objWheel(i).SetOnTouchListener("scv_Touch")
		objWheel(i).RunMethod2("setSmoothScrollingEnabled", False, "java.lang.boolean")
'		objWheel(i).RunMethod2("setSmoothScrollingEnabled", True, "java.lang.boolean")
		For j = 0 To WheelContent(i).Size + ItemNb
			Dim lbl As Label
			lbl.Initialize("")
			scvWheel(i).Panel.AddView(lbl, 0, j * lblHeight, ColWidths(i), lblHeight)
			lbl.Gravity = Gravity.CENTER_HORIZONTAL + Gravity.CENTER_VERTICAL
			lbl.Color = Colors.Transparent
			lbl.TextColor = Colors.Black
			lbl.TextSize = FontSize
			If j >= ItemNb_2 AND j <= WheelContent(i).Size + ItemNb_2 - 1 Then
				lbl.Text = WheelContent(i).get(j - ItemNb_2)
			Else
				lbl.Text = ""
			End If
		Next
' test code, I left it here for memory.
'		scvWheel(i).Panel.Width = scvWheel(i).Width
'		cvsWheel.Initialize(scvWheel(i).Panel)
'		x1 = 0
'		x2 = x1 + scvWheel(i).Panel.Width
'		y2 = lblHeight * WheelContentNb(i)
'		cvsWheel.DrawLine(x1, y2, x2, y2, Colors.Green, lineWidth)
'		y2 = lblHeight * 2 * WheelContentNb(i)
'		cvsWheel.DrawLine(x1, y2, x2, y2, Colors.Green, lineWidth)
	Next

	pnlTop.Initialize("")
	pnlBackGround.AddView(pnlTop, 0, 0, TotalColWidths(WheelNb), ItemNb_2 * lblHeight)

	pnlMiddle.Initialize("")
	pnlBackGround.AddView(pnlMiddle, lineWidth, 0 + ItemNb_2 * lblHeight, TotalColWidths(WheelNb) - 2 * lineWidth, lblHeight)
	pnlMiddle.Color = colWindow
	
	pnlBottom.Initialize("")
	pnlBackGround.AddView(pnlBottom, 0, 0 + (ItemNb_2 + 1) * lblHeight, TotalColWidths(WheelNb), ItemNb_2 * lblHeight)

	setShadowColor(colShadow)
	setWindowColor(colWindow)
	setWindowLineColor(colWindowLine)
	
	Width = pnlBackGround.Width
	Height = pnlBackGround.Height
	
End Sub

'Show the wheel panel
'cEventName = EventName for the _Closed event
'DefaultValue = the wheels will be set to this value
'Enter "" for now (for DATE, TIME_HM. TIME_HMS and DATE_TIME
'Example:
'<code>TimeHMWheel.Show2 ("TimeHMWheel", "")</code>
Public Sub Show2(DefaulValue As String)
	InitDefaultValues(DefaulValue)
End Sub

Private Sub Hide_holder
	holder.Visible = False
End Sub

Private Sub InitDefaultValues(DefaultValue As String)
	Dim i As Int
'	Dim Ticks As Long

	Select WheelType
	Case TIME_HM
		Dim Hour, Minute As Int
		If DefaultValue = "" Then
			Hour = DateTime.GetHour(DateTime.Now)
			Minute = DateTime.GetMinute(DateTime.Now)
		Else
			Dim TimeFormat As String
			TimeFormat = DateTime.TimeFormat
			DateTime.TimeFormat = "HH:mm"
			Hour = DateTime.GetHour(DateTime.TimeParse(DefaultValue))
			Minute = DateTime.GetMinute(DateTime.TimeParse(DefaultValue))
			DateTime.TimeFormat = TimeFormat
		End If
		ScrollPos(0) = lblHeight * (Hour + WheelContentNb(0))
		ScrollPos(1) = lblHeight * (Minute + WheelContentNb(1))
	Case VALUE1
		If DefaultValue = "" Then
			For i = 0 To WheelNb - 1
				ScrollPos(i) = 0
			Next
		Else 
			Dim Txt(WheelNb) As Int
			For i = 0 To WheelNb - 1
				Txt(i) = DefaultValue ' DefaultValue.SubString2(i,i+1)
				ScrollPos(i) = lblHeight * WheelContent(i).IndexOf(Txt(i))
			Next
		End If
	Case CUSTOM
		If DefaultValue = "" Then
			For i = 0 To WheelNb - 1
				ScrollPos(i) = 0
			Next
		Else 
			Dim intPos As Int =  DefaultValue.IndexOf("h")
			If intPos = -1 Then
				intPos =  DefaultValue.IndexOf("m")
			End If
			If intPos = -1 Then
				intPos =  DefaultValue.IndexOf("d")
			End If
			If intPos > 0 Then
				Dim DefaultValueSub As String = DefaultValue.SubString2(0,intPos+1)
				DefaultValueSub = Common.PadLeft(DefaultValueSub, "0",4)
'				Log("DefaultValueSub " & DefaultValueSub)
				Dim strTxt(WheelNb) As String
				For i = 0 To DefaultValueSub.Length -1
					strTxt(i) = DefaultValueSub.SubString2(i,i+1)
					ScrollPos(i) = lblHeight * WheelContent(i).IndexOf(strTxt(i))
				Next
				strTxt(i) = DefaultValue.SubString(intPos+1)
'				Log("DefaultValueSub " & DefaultValue.SubString(intPos+1))
				ScrollPos(i) = lblHeight * WheelContent(i).IndexOf(strTxt(i))
			Else
				ToastMessageShow("Wrong format: use m/h/d only in the middle",True)
			End If
		End If
	End Select

	holder.Visible = True
	
	For i = 0 To WheelNb - 1
		objWheel(i).RunMethod3("scrollTo", 0, "java.lang.int", ScrollPos(i), "java.lang.int")
		DoEvents
		objWheel(i).RunMethod3("scrollTo", 0, "java.lang.int", ScrollPos(i), "java.lang.int")
		DoEvents
		objWheel(i).RunMethod3("scrollTo", 0, "java.lang.int", ScrollPos(i), "java.lang.int")
		DoEvents
		objWheel(i).RunMethod3("scrollTo", 0, "java.lang.int", ScrollPos(i), "java.lang.int")
		DoEvents
		DoEvents
		DoEvents
	Next
End Sub

'Get the result of the selection as a string
'For DATE, TIME_HM, TIME_HMS and DATE_TIME
'Returns a String with the defined DateFormat and TimeFormat
Public Sub getSelection As String
	Dim i, j As Int
	Dim Sel(WheelNb) As String
	Dim Selection As String
	
	Selection = ""
	For i = 0 To WheelNb - 1
		Dim lbl As Label
		j = Floor(scvWheel(i).ScrollPosition / lblHeight + 0.5) + 2
		lbl = scvWheel(i).Panel.GetView(j)
		Sel(i) = lbl.Text
	Next 

	Select WheelType
	Case TIME_HM
		Selection = Sel(0) & ":" & Sel(1)
		Selection = GetTimeHM(Selection)
	Case VALUE1
		Dim i As Int
		Selection = Sel(0)
		If WheelNb > 1 Then
			For i = 1 To WheelNb -1
				Selection = Selection & Sel(i)
			Next
		End If
	Case CUSTOM
		Dim i As Int
		Selection = Sel(0)
		If WheelNb > 1 Then
			For i = 1 To WheelNb -1
				Selection = Selection & Sel(i)
			Next
		End If	
	End Select

	Return Selection
End Sub

'Change the Time HH:mm from the internal format to the default format
Private Sub GetTimeHM(Time1 As String) As String
	Dim TimeFormat, Time2 As String
	Dim TimeTicks As Long
	
	TimeFormat = DateTime.TimeFormat
	DateTime.TimeFormat = "HH:mm"
	
	TimeTicks = DateTime.TimeParse(Time1)
	DateTime.TimeFormat = TimeFormat
	Time2 = DateTime.TIME(TimeTicks)
	Return Time2
End Sub

'Initialize the TIME_HM wheel, used inernally
Sub InitializeTime_HM
	Dim i, j As Int
	
	WheelNb = 2
	
	Dim WheelContent(WheelNb) As List
	Dim WheelContentNb(WheelNb) As Int
	Dim ScrollPos(WheelNb) As Int
	
	WheelContent(0).Initialize
	WheelContentNb(0) = 24
	For j = 0 To WheelContinus
		For i = 0 To 23
			WheelContent(0).Add(i)
		Next
	Next
	
	WheelContent(1).Initialize
	WheelContentNb(1) = 60
	For j = 0 To WheelContinus
		For i = 0 To 59
			WheelContent(1).Add(NumberFormat(i, 2, 0))
		Next
	Next

	If WheelContinus = 0 Then
		For i = 0 To WheelNb - 1
			WheelContentNb(i) = 0
		Next
	End If
End Sub

Sub InitializeValue1
	Dim i As Int
	
	WheelNb = 1 
	
	Dim WheelContent(WheelNb) As List
	Dim ScrollPos(WheelNb) As Int
	
	WheelContent(0).Initialize
	For i = 3 To 30
		WheelContent(0).Add(i)
	Next
		
End Sub

Sub InitializeCustom
	Dim i As Int
	
	WheelNb = 5
	
	Dim WheelContent(WheelNb) As List
	Dim ScrollPos(WheelNb) As Int
	
	For j = 0 To 2
		WheelContent(j).Initialize
		For i = 0 To 9
			WheelContent(j).Add("" & i)		' convert to string
		Next
	Next 
	
	WheelContent(3).Initialize
	WheelContent(3).Add("d")
	WheelContent(3).Add("h")
	WheelContent(3).Add("m")
	
	WheelContent(4).Initialize
	For i = 1 To 12
		WheelContent(4).Add("" & i)		' convert to string
	Next
	
End Sub

#Region  Wheel technical setup 

#Region  Property 

'Sets or gets the background color equivalent to the line color
Public Sub setBackgroundColor(col As Int)
	colBackGround = col
	pnlBackGround.Color = colBackGround
End Sub

Public Sub getBackgroundColor As Int
	Return colBackGround
End Sub

'Sets or gets the shadow color, default color = black
Public Sub setShadowColor(col As Int)
	colShadow = col
	Dim gdw As GradientDrawable
	Dim cols(2) As Int
	cols(0) = colShadow
	cols(1) = Colors.Transparent
	gdw.Initialize("TOP_BOTTOM", cols)
	gdw.CornerRadius = 0
	pnlTop.Background = gdw

	Dim gdw As GradientDrawable
	gdw.Initialize("BOTTOM_TOP", cols)
	gdw.CornerRadius = 0
	pnlBottom.Background = gdw
End Sub

Public Sub getShadowColor As Int
	Return colShadow
End Sub

'Sets or gets the central window color.
'If the alpha part is greater than 128 the program limits it to 128
Public Sub setWindowColor(col As Int)
	Dim argb() As Int
	argb = getARGB(col)
	If argb(0) > 128 Then
		argb(0) = 128
		colWindow = Colors.argb(argb(0), argb(1), argb(2), argb(3))
	Else
		colWindow = col
	End If
	pnlMiddle.Color = colWindow
End Sub

'Get the color components, returns an array with the four component values
Private Sub getARGB(Color As Int) As Int()
	Dim cols(4) As Int
	cols(0) = Bit.UnsignedShiftRight(Bit.AND(Color, 0xff000000), 24)
	cols(1) = Bit.UnsignedShiftRight(Bit.AND(Color, 0xff0000), 16)
	cols(2) = Bit.UnsignedShiftRight(Bit.AND(Color, 0xff00), 8)
	cols(3) = Bit.AND(Color, 0xff)
	Return cols
End Sub

Public Sub getWindowColor As Int
	Return colWindow
End Sub

'Sets or gets the central window frame line color
Public Sub setWindowLineColor(col As Int)
	colWindowLine = col
	cvsTop.Initialize(pnlTop)
	cvsTop.DrawLine(lineWidth, pnlTop.Height - lineWidth / 2, TotalColWidths(WheelNb) - lineWidth, pnlTop.Height - lineWidth / 2, colWindowLine, lineWidth)

	cvsBottom.Initialize(pnlBottom)
	cvsBottom.DrawLine(lineWidth, lineWidth / 2, TotalColWidths(WheelNb) - lineWidth, lineWidth / 2, colWindowLine, lineWidth)
End Sub

Public Sub getWindowLineColor As Int
	Return colWindowLine
End Sub

'Sets the vertical scrollbar
'or gets if the vertical scrollbar is enabled
Public Sub setVerticalScrollBar(VScrollBar As Boolean)
	If cVerticalScrollBar <> VScrollBar Then
		cVerticalScrollBar = VScrollBar
		Dim objWheel(WheelNb) As Reflector
		Dim i As Int
		For i = 0 To WheelNb - 1
			objWheel(i).Target = scvWheel(i)
			objWheel(i).RunMethod2("setVerticalScrollBarEnabled", cVerticalScrollBar, "java.lang.boolean")
		Next
	End If
End Sub

Public Sub getVerticalScrollBar As Boolean
	Return cVerticalScrollBar
End Sub

#End Region

Private Sub scv_Touch(ViewTag As Object, Action As Int, X As Float, Y As Float, MotionEvent As Object) As Boolean
	Dim dt As Long
	Dim tt As Int
	
	Select Action
	Case 0	' ACTION_DOWN
		t1 = DateTime.Now
		y1 = Y
	Case 1	' ACTION_UP
		tt = Max(10, -Logarithm(1 / speed, cE) * 110)
		CurrentScrollView = Sender
		TimerWheel.Interval = tt * 1.5
		TimerWheel.Enabled = True
	Case 2	' ACTION_MOVE
		dt = (DateTime.Now - t1)
		speed = Abs((Y - y1) / dt * 250)
		y1 = Y
		t1 = DateTime.Now
	End Select
	
	Return False
End Sub

Private Sub ScrollFinish(S As ScrollView, Pos As Int)
	'Dim i, IndexMonth, Year, DAYS, PosNew As Int
	Dim PosNew As Int
'
'	i = S.Tag
'
'	If Pos < WheelContentNb(i) * lblHeight Then
'		PosNew = Pos + WheelContentNb(i) * lblHeight
'	Else If Pos > 2 * WheelContentNb(i) * lblHeight Then
'		PosNew = Pos - WheelContentNb(i) * lblHeight
'	Else
		PosNew = Pos
'	End If
'	If PosNew <> Pos Then
'		objWheel(i).RunMethod2("setSmoothScrollingEnabled", False, "java.lang.boolean")
'		DoEvents
'		DoEvents
'		objWheel(i).RunMethod3("scrollTo", 0, "java.lang.int", PosNew, "java.lang.int")
'		DoEvents
'		DoEvents
'		objWheel(i).RunMethod3("scrollTo", 0, "java.lang.int", PosNew, "java.lang.int")
'		DoEvents
'		DoEvents
'		objWheel(i).RunMethod2("setSmoothScrollingEnabled", True, "java.lang.boolean")
'		DoEvents
'	End If
'	
	PosNew = Floor(PosNew/lblHeight + .5)
	PosNew = PosNew * lblHeight
	S.ScrollPosition = PosNew			' copy the logic from V 1.2
'	objWheel(i).RunMethod3("smoothScrollTo", 0, "java.lang.int", PosNew, "java.lang.int")
'	DoEvents

End Sub

Private Sub TimerWheel_Tick
	TimerWheel.Enabled = False
	ScrollFinish(CurrentScrollView, CurrentScrollView.ScrollPosition)
End Sub

#End Region

Private Sub btnCancel_Click
	CallSub3(mTarget, mEventName & "_Closed", True, getSelection)
	holder.RemoveView
End Sub

Private Sub btnOK_Click
	CallSub3(mTarget, mEventName & "_Closed", False, getSelection)
	holder.RemoveView
End Sub

Private Sub pnlMain_Click
	' empty to consume the events
End Sub

