﻿Type=StaticCode
Version=2.71
@EndOfDesignText@
'Code module
'Subs in this code module will be accessible from all modules.
Sub Process_Globals
	'These global variables will be declared once when the application starts.
	'These variables can be accessed from all modules.

End Sub

Sub DayOfWeek(DateTicks As Long, bShort As Boolean) As String
	Dim daysNames(7) As String
	Dim i As Int = 0
	' American - start on Sunday - original
	For Each d As String In DateUtils.GetDaysNames
		daysNames(i) = d
		i = i + 1
	Next
	Dim day As String = ""
	Dim day As String = daysNames(DateTime.GetDayOfWeek(DateTicks) - 1)
	If bShort Then
		day = day.SubString2(0,3)
	End If
	
	Return day
	
End Sub

Sub WeekOfDayGet(BitwiseDOWeek As Int) As List

	Dim DOWeek As List
	DOWeek.Initialize
	For i = 1 To 7 
		If Bit.AND(BitwiseDOWeek, Power(2,i)) > 0 Then
			DOWeek.Add(i)
		End If
	Next
			
	Return DOWeek
	
End Sub

Sub DOWeek_list(BitwiseDOWeek As Int) As String
	Dim daysNames(7) As String
	Dim i As Int
	' American - start on Sunday - original
	For Each d As String In DateUtils.GetDaysNames
		daysNames(i) = d.SubString2(0,2)
		i = i + 1
	Next
	
	' 1st day = Monday
	Dim DOWeek As String
	For i = 2 To 7
		If Bit.AND(BitwiseDOWeek, Power(2,i)) > 0 Then
			DOWeek = DOWeek & daysNames(i-1)
		End If
	Next
	If Bit.AND(BitwiseDOWeek, 2) > 0 Then
		DOWeek = DOWeek & daysNames(0)
	End If
		
	Return DOWeek
	
End Sub

Sub DisplayDOWDate(strDate As String) As String

	Dim strDOW As String = DayOfWeek(DateTime.DateParse(strDate), False)
	If strDOW = "Wednesday" Then
		strDOW = "Wedsday"
'	Else If strDOW = "Saturday" Then
'		strDOW = "Satrday"
	End If
	DateTime.Dateformat = "MM/dd/yy"
	Dim strDateX As String = DateTime.Date(DateTime.DateParse(strDate))
	DateTime.Dateformat = "MM/dd/yyyy"
	
	Return (strDOW & CRLF & strDateX)
	
End Sub

Sub DateWOCentury(date As String) As String
	'Log("DateWOAge" & date)
	DateTime.DateFormat = "MM/dd/yyyy"
	Dim lngDate As Long = DateTime.DateParse(date)
	DateTime.DateFormat = "MM/dd/yy"
	Dim strDate As String = DateTime.date(lngDate)
	DateTime.DateFormat = "MM/dd/yyyy"
	
	Return strDate
End Sub

Sub ConvertToAmPm(Hour As Int) As String()
	' NJDude - b4a
	Dim HourMeridian(2) As String 
	Dim meridian As String
	If Hour < 12 Then meridian = "AM"
	If Hour = 12 Then meridian = "PM"
	If Hour = 0 Then
	   Hour = 12
	   meridian = "AM"
	End If

	If Hour > 12 Then
	   Hour = Hour - 12
	   meridian = "PM"
	End If
	HourMeridian(0) = Hour
	HourMeridian(1) = meridian
	
	Return HourMeridian
	
End Sub

Sub TimeIn12(StrTime As String) As String()
	' the Fontsize of the hour & minute and am/pm will be shown with different size.
	Dim intPos As Int = StrTime.IndexOf(":") 
	Dim intHour As Int = StrTime.SubString2(0,intPos)
	Dim strMinute As String = StrTime.SubString(intPos+1)
	Dim HourMeridian() As String = ConvertToAmPm(intHour)
		
	Return Array As String(HourMeridian(0) & ":" & strMinute, HourMeridian(1))
End Sub

Sub Intxtimes_hour(IntxTimes As String) As Int

	Dim intPos As Int =  IntxTimes.IndexOf("h")
	If intPos = -1 Then
		intPos =  IntxTimes.IndexOf("m")
	End If
	If intPos = -1 Then
		intPos =  IntxTimes.IndexOf("d")
	End If
	If intPos > 0 Then
		Dim intRepeat As Int =  IntxTimes.SubString(intPos+1)
		Dim intMinutes As Int =  IntxTimes.SubString2(0,intPos)
		If intRepeat > 0 AND intMinutes > 0 Then
			Dim intHours As Int 
			intHours = intMinutes * intRepeat
			If  IntxTimes.Contains("m") Then
				intHours = intHours/60
			Else If IntxTimes.Contains("d") Then
				intHours = intHours * 24
			End If
		Else
			ToastMessageShow("Wrong format: interval and times must be a digit",True)
		End If
	Else
		ToastMessageShow("Wrong format: use m/h/d only in the middle",True)
	End If
	
	Return intHours
	
	
End Sub
Sub IntxTimes_Conv(IntxTimes As String) As String

	Dim intPos As Int =  IntxTimes.IndexOf("h")
	If intPos = -1 Then
		intPos =  IntxTimes.IndexOf("m")
	End If
	If intPos = -1 Then
		intPos =  IntxTimes.IndexOf("d")
	End If
	If intPos > 0 Then
		Dim intMinutes As Int =  IntxTimes.SubString2(0,intPos)
		Dim intRepeat As Int =  IntxTimes.SubString(intPos+1)
		If intRepeat > 0 AND intMinutes > 0 Then
			Dim strText As String 
			If  IntxTimes.Contains("d") Then
				strText = intMinutes & " day(s) x " & intRepeat
			Else If  IntxTimes.Contains("h") Then
				strText = intMinutes & " hour(s) x " & intRepeat
			Else
				strText = intMinutes & " minute(s) x " & intRepeat
			End If
		Else
			Msgbox("Wrong format: interval and times must be a digit","")
		End If
	Else
		Msgbox("Wrong format: use m/h/d only in the middle","")
	End If
	
	Return strText
	
End Sub

Sub Minutes2Str(IntMinutes As Int) As String
	Dim strDescription As String
	If IntMinutes < 60 Then
		strDescription = IntMinutes & " min."
	Else
		Dim intAdjustH As Int = (IntMinutes/60)
		strDescription = intAdjustH & " hour(s) "
		If (IntMinutes Mod 60) > 0 Then
			strDescription = strDescription & (IntMinutes Mod 60) & " min."
		End If
	End If
	
	Return strDescription
	
End Sub


Sub PadLeft(Source As String, PadChar As String, Length As Int) As String

	'source = numberformat(source,length,0)
	'Log("PadLeft0: " & Source)
	For i = 0 To Length-1
		If Source.Length = Length Then
			Exit
		End If
		Source = PadChar & Source
	Next
	'Log("PadLeft1: " & Source)
	Return Source
	
End Sub

Sub RingtoneName(Uri As String) As String
		' Thanks to Stevel05 - b4a
		
		' http://stackoverflow.com/questions/4498315/get-the-ringtone-title-from-ringtonepreference
		' 'In Java:
		' Uri ringtoneUri = Uri.parse(strRingtonePreference);
		' Ringtone ringtone = RingtoneManager.getRingtone(context, ringtoneUri);
		' String Name = ringtone.getTitle(context);

		Try
			'Log("RingToneURI="&Uri)
	 		Dim R As Reflector
			'Convert the selected Uri string to a Uri Object compatible with the get ringtone method.
	        Dim rtUri As Object = R.RunStaticMethod("android.net.Uri","parse",Array As Object(Uri),Array As String("java.lang.String"))
	        'Get the actual ringtone from the Uri
	        R.Target = R.RunStaticMethod("android.media.RingtoneManager","getRingtone",Array As Object(R.GetContext,rtUri),Array As String("android.content.Context","android.net.Uri"))
	        'Get the title from the ringtone
	        Dim Name As String = R.RunPublicmethod("getTitle",Array As Object(R.GetContext),Array As String("android.content.Context"))
	        'Silent returns Unknown ringtone
	      	'Log("RingToneName="&Name)
		Catch
			Name = "Silent"
		End Try
		
	Return Name
	
End Sub

Sub Split(text As String) As List
	'Regex.Split("\n", text)
	Dim lstText As List
	lstText.Initialize
	Dim intpos As Int
	Do While text.Length > 0
		intpos = text.IndexOf(CRLF)
		If intpos-1 < 0 Then
			lstText.Add(text)
			Exit
		End If
		lstText.Add(text.SubString2(0,intpos))
		text = text.SubString(intpos+1)
	Loop
		
	Return lstText
	
End Sub

Sub IsDate(strDate As String) As Boolean

	DateTime.DateFormat = "MM/dd/yy"
	Try
		DateTime.DateParse(strDate)
	Catch
		DateTime.DateFormat = "MM/dd/yyyy"
		Return False
	End Try
	DateTime.DateFormat = "MM/dd/yyyy"
	Return True

	
End Sub
