﻿Type=Activity
Version=2.71
@EndOfDesignText@
#Region  Activity Attributes 
	#FullScreen: False
	#IncludeTitle: True
#End Region

Sub Process_Globals
	'These global variables will be declared once when the application starts.
	'These variables can be accessed from all modules.
	
End Sub

Sub Globals
	'These global variables will be redeclared each time the activity is created.
	'These variables can only be accessed from this module.
	
	Dim lblSnooze As Label
	
	Private Panel1 As Panel
	Private Panel2 As Panel
	Private Panel3 As Panel
	Private Panel4 As Panel
	
	Private Label1a As Label
	Private Label1b As Label
	Private Label2 As Label
	Private lblAmPm As Label
	
	Private scvNotes As ScrollView
	Private scvSchedule As ScrollView
	Private lblSchedule As Label
	
	Private gd As GestureDetector
	Private pnlGesture As Panel
	
	Private StringUtils1 As StringUtils
	
	Dim NumberOfColumns As Int = 5
	Dim NumberOfRows0 As Int
	Dim colWidth(NumberOfColumns) As Int
	Dim colOffset(NumberOfColumns) As Int
	Dim rowHeight As Int = 50dip
	
	' to prevent twice execution in succesion 	' actually not critical
	' it seem it happened when the screen is sleeping mode
	Private blnResume As Boolean = True 
	
	' Should be redefine here, can not use definition from the main
	' if the application is deleted from memory.
	Private TextSizeStd0 As Float
	
	Private mMsgBox As ClsDialog	
	
End Sub

Sub Activity_Create(FirstTime As Boolean)
	'Do not forget to load the layout file created with the visual designer. For example:

	DoEvents	' don't delete, for preventing 100%y including the bottom bar 
				' at activation from sleep???
	
	Activity.LoadLayout("RingAction")
	Activity.Title = "Alarm"
	
	pnlGesture.Initialize("")	' initialize the scroll panel
	
	Panel1.SetLayout(0,0,100%x,40%y)
	Panel2.SetLayout(0,Panel1.top+Panel1.height,100%x,35%y)
	Panel3.SetLayout(0,Panel1.Height+Panel2.height,100%x,25%y)
		
	Panel4.RemoveView
	Panel3.AddView(Panel4, Panel3.width - 17%x, 0, 17%x, Panel3.Height)
	Panel3.AddView(pnlGesture, Panel3.width - 17%x, 0, 17%x, Panel3.Height)
	
	Label1a.SetLayout(0,1%y,45%x, 10%y)
	Label1b.SetLayout(45%x,0,30%x, 12%y)
	lblAmPm.SetLayout(76%x,2%y,20%x, 7%y)
	Label2.SetLayout(0,12%y,100%x, 5%y)
	Label2.Color = Colors.ARGB(255,241,239,226)
	
	Dim acc As Accessiblity
	TextSizeStd0 = Label2.TextSize	/ acc.GetUserFontScale
	'TextSizeStd0 = 0.45 * Label2.height	/ acc.GetUserFontScale
			
	Label2.TextSize = TextSizeStd0
	Label1a.TextSize = 16/15 * TextSizeStd0
	Label1b.TextSize = 34/15 * TextSizeStd0
	lblAmPm.TextSize = 22/15 * TextSizeStd0
	lblSnooze.TextSize = 30/15 * TextSizeStd0
	
	scvNotes.SetLayout(0,17%y,100%x,Panel1.height-(Label1b.height+Label2.height))
	
	lblSchedule.SetLayout(0,0,100%x,rowHeight)
	lblSchedule.Color = Colors.ARGB(255,241,220,100) 
	lblSchedule.TextSize = TextSizeStd0
	
	scvSchedule.SetLayout(0,rowHeight,100%x,Panel2.Height-rowHeight)
	scvSchedule.color = Colors.ARGB(255,241,239,150)
	
	colWidth(0) = .23*Panel2.Width
	colWidth(1) = .16*Panel2.Width
	colWidth(2) = .05*Panel2.Width
	colWidth(3) = .46*Panel2.Width
	colWidth(4) = .10*Panel2.Width
	colOffset(0) = 0
	colOffset(1) = colWidth(0)
	colOffset(2) = colOffset(1) + colWidth(1)
	colOffset(3) = colOffset(2) + colWidth(2)
	colOffset(4) = colOffset(3) + colWidth(3)
	
	lblSnooze.SetLayout(0,0,Panel3.width - 17%x,Panel3.Height)

	pnlGesture.Tag = "pnl"
	pnlGesture.Color = Colors.Transparent
	gd.SetOnGestureListener(Activity, "Gesture")
	pnlGesture.BringToFront
	
	If CheckLock Then	' actually it is fine without this check.
		SetShowWhenLocked
	End If

	' Menu 
	Activity.AddMenuItem("Task Setup","TaskSetup")
	
	mMsgBox.Initialize(Me, "MsgBox")
	
End Sub

Sub Activity_Resume

	If blnResume Then
		
		Log("RingAction.Activity_Resume")
		
		lblSnooze.Text = "Snooze" & CRLF & AlarmService.SnoozeCount & " of " & TimeManager.Snoozes
		
		If AlarmService.SnoozeCount > 0 Then
			Dim Diff As Long = TimeManager.DateTimeTicks - DateTime.DateTimeParse(TimeManager.date,TimeManager.time & ":00")
			Label2.Text = "Past: " & (Diff / (60 * 1000)) & " minutes"
		Else 
			Label2.Text = ""
		End If
		
		If TimeManager.DateTimeTicks > 0 Then
		
			DateTime.DateFormat = "dd MMM"
			Dim strDate As String = DateTime.Date(TimeManager.DateTimeTicks)
			Dim strDate As String = DateTime.Date(TimeManager.DateTimeTicks)
			If strDate.StartsWith("0") Then
				strDate = strDate.SubString(1)
			End If
			DateTime.DateFormat = "dd/MM/yyyy"
			If DateTime.Date(TimeManager.DateTimeTicks) = DateTime.Date(DateTime.Now) Then
				Label1a.Text = TimeManager.dayweek1 & CRLF & "Today: " & strDate
			Else If DateTime.Date(TimeManager.DateTimeTicks) = DateTime.Date(DateTime.Add(DateTime.Now,0,0,1)) Then
				Label1a.Text = TimeManager.dayweek1 & CRLF & "Tomorrow: " & strDate
			Else
				DateTime.DateFormat = "dd MMM yyyy"
				strDate = DateTime.Date(TimeManager.DateTimeTicks)
				DateTime.DateFormat = "MM/dd/yyyy"
				Label1a.Text = TimeManager.dayweek1 & CRLF & strDate
			End If
			
			lblAmPm.visible = False
			Label1b.Text = TimeManager.time
			If Main.TimeFormat = 12 Then
				lblAmPm.visible = True
				Dim Value() As String = Common.TimeIn12(TimeManager.time)
				lblAmPm.Text = Value(1)
				Label1b.Text = Value(0)
			End If
		Else
			lblAmPm.visible = False
			Label1a.Text = ""
			Label1b.Text = ""
			Label2.Text = ""
		End If
		
		SetText(TimeManager.notes)
		
		DoEvents
	
		'Log("Activity_Resume: " & TimeManager.ListSchedule.Size)
		NumberOfRows0 = 0
		DateTime.DateFormat = "MM/dd/yyyy"	' to make sure it has the standard format
	
		For i = 0 To TimeManager.ListSchedule.Size - 1
			Dim row() As String = TimeManager.ListSchedule.Get(i)
			'Log("Group: " & row(6) & " " & intGroupSlct)
			If DateTime.DateTimeParse(row(2), row(3) & ":00") < DateTime.Now Then
				AddRow0(row)
			End If
		Next
		scvSchedule.Panel.Height = NumberOfRows0 * rowHeight 
	
		LinkToDone
		
		DoEvents

	End If
	
	blnResume = False
	
End Sub

Sub Activity_Pause (UserClosed As Boolean)
	
	blnResume = True
	
End Sub

Sub Activity_KeyPress (KeyCode As Int) As Boolean 'Return True to consume the event
    
	Select Case KeyCode
    	Case KeyCodes.KEYCODE_VOLUME_UP, KeyCodes.KEYCODE_VOLUME_DOWN 
	        lblSnooze_Click
	        Return True
    End Select 
	
	Return False
	
End Sub

Sub TaskSetup_click

	TaskSetup.EditStatus = "New"
	StartActivity("TaskSetup")
	
End Sub

Sub CheckLock As Boolean

	Dim r As Reflector
	r.Target = r.GetContext
	r.Target = r.RunMethod2("getSystemService", "keyguard", "java.lang.String")
	Return  r.RunMethod("inKeyguardRestrictedInputMode")
	
End Sub

Sub SetShowWhenLocked
	' Don't put it in service module!
	'Log("SetShowWhenLocked")
	
    Dim r As Reflector
    r.Target = r.GetActivity
    r.Target = r.RunMethod("getWindow")
	r.RunMethod2("addFlags", 6815744, "java.lang.int")
	' the FLAG_KEEP_SCREEN_ON is replace by phw.KeepAlive(True) in AlarmService
	' if not, it must be cancelled by using sub KEEP_SCREEN_ON_clr below to goToSleep.
	' the problem is how to reactivate it after snooze.
	' original:
    'r.RunMethod2("addFlags", 6815872, "java.lang.int")
	' 6815872 = Addition of
	' FLAG_TURN_SCREEN_ON = 2097152
	' FLAG_DISMISS_KEYGUARD = 4194304
	' FLAG_SHOW_WHEN_LOCKED = 524288
	' FLAG_KEEP_SCREEN_ON = 128
			
	' This make the activity_resume execute???
	
End Sub

'Sub KEEP_SCREEN_ON_clr
'
'	' to release:
'	Dim r As Reflector
'    r.Target = r.GetActivity
'    r.Target = r.RunMethod("getWindow")
'	r.RunMethod2("clearFlags", 128, "java.lang.int")
'		
'End Sub

' The following sub is move to Alarm Service to anticipate
' if the ringaction is paused! 
' Failed to wakeup the Android!

'Sub btnDismis_Click
'	TimeManager.noti.Cancel(1)
'	CallSub(AlarmService,"Service_Destroy")
'	' set for the next alarm
'	AlarmService.SnoozeCount = 0
'	CallSub(TimeManager,"Select_Next") 
'End Sub
'
'Sub btnSnooze_Click
'	Log("snooze click")
'	TimeManager.noti.Cancel(1)
'	CallSub(AlarmService,"Service_Destroy")
'	DoEvents
'	AlarmService.SnoozeCount = TimeManager.SnoozeCount + 1
'	If TimeManager.SnoozeCount < TimeManager.Snoozes Then
'		TimeManager.DateTimeTicks = TimeManager.DateTimeTicks + TimeManager.TimeBetweenSnoozes * 1000
'		CallSub(TimeManager,"Alarm_Set")
'	Else
'		btnDismis_Click
'	End If
'End Sub

#Region  workaround for the above problem 

Sub btnDismis_Click

'	Log("btnDismis_Click: " & DateTime.Time(TimeManager.DateTimeTicks))
	If TimeManager.DateTimeTicks < DateTime.Now OR _
			AlarmService.SnoozeCount > 0 Then
'		Log("btnDismis_Click")
		CallSubDelayed(AlarmService,"btnDismis_click")
	End If
	Activity.Finish
	
End Sub

Sub lblSnooze_Click

'	Log("lblSnooze_Click: " & DateTime.Time(TimeManager.DateTimeTicks))
	If TimeManager.DateTimeTicks < DateTime.Now Then
'		Log("lblSnooze_Click")
		CallSubDelayed(AlarmService,"btnSnooze_click")
	End If
	' if directly close, the notes can not be read!
	' but if not closed, the snooze can be push multiple times.
	Activity.Finish
	
End Sub

#End Region 

Sub Gesture_onSingleTapConfirmed(X As Float, Y As Float, MotionEvent As Object)
'	Log("   onSingleTapConfirmed x = " & X & ", y = " & Y & ", ev = " & MotionEvent)
	lblSnooze_Click
'	Log("gesture snooze")

End Sub

Sub Gesture_onScroll(distanceX As Float, distanceY As Float, MotionEvent1 As Object, MotionEvent2 As Object)
'	Log("   onScroll distanceX = " & distanceX & ", distanceY = " & distanceY & ", ev1 = " & MotionEvent1 & ", ev2=" & MotionEvent2)
'	Log("      X1, Y1 = " & gd.getX(MotionEvent1, 0) & ", " & gd.getY(MotionEvent1, 0))
'	Log("      X2, Y2 = " & gd.getX(MotionEvent2, 0) & ", " & gd.getY(MotionEvent2, 0))

	Dim Y1 As Float = gd.getY(MotionEvent1, 0)
	Dim Y2 As Float = gd.getY(MotionEvent2, 0)
'	Log("Distance: " & (Y2-Y1) & " " & distanceY)
	If Y1 < Y2 AND (Y2-Y1) > 150 Then
		' down
		btnDismis_Click
	End If
		
End Sub

Sub SetText(txt As String)
	Dim ht As Float = 10dip	' just any arbitrary value
	Dim top As Float = 0
	Dim topOffset As Float = top
	
	Dim lstText As List = Common.Split(txt)
	Dim lbl(lstText.Size) As Label
		
	scvNotes.Panel.RemoveAllViews
	For i = 0 To lstText.size - 1
		'Log(lstText)
		lbl(i).Initialize("")
		lbl(i).Text = lstText.Get(i)
		lbl(i).TextSize = TextSizeStd0
		lbl(i).Gravity = Gravity.CENTER
		lbl(i).TextColor = Colors.Black
		scvNotes.Panel.AddView(lbl(i), 0, top, 100%x, ht)
		Dim lbl1 As Label = scvNotes.Panel.GetView(i)
		ht = StringUtils1.MeasureMultilineTextHeight(lbl1, lbl1.Text)
		lbl1.Height = ht
		top = top + ht
	Next
	
	If top < Panel1.height-(Label1b.height+Label2.height) Then
		' make it center-vertical
		Dim topOffset As Float = (Panel1.height-(Label1b.height+Label2.height)-top)/2
		scvNotes.Panel.RemoveAllViews
		For i = 0 To lstText.Size - 1
			scvNotes.Panel.AddView(lbl(i), 0, lbl(i).top+topOffset, 100%x, lbl(i).Height)
		Next
		scvNotes.Panel.Height = Panel1.height-(Label1b.height+Label2.height)
	Else
		scvNotes.Panel.Height = top
	End If
	
	DoEvents
	
End Sub

#Region  List Previous Schedule 

Sub AddRow0(values() As String)
	'Log("addrow0: " & values(2) & " " & values(3) & " " & values(4))
	
	DoEvents
	
	Dim rc As RowCol
	rc.Row = NumberOfRows0
	For i = 2 To 5
		Dim lbl As Label
		lbl.Initialize("cell")
		lbl.TextSize = TextSizeStd0
		lbl.TextColor = Colors.Black
		lbl.Color = Colors.ARGB(255,241,239,150) 
		lbl.Gravity = Gravity.CENTER_HORIZONTAL + Gravity.CENTER_VERTICAL
		Select Case i
			Case 2 
				DateTime.dateformat = "MM/dd/yyyy"
				If values(i) = DateTime.Date(DateTime.Now) Then
					lbl.Text = "Today"
				Else
					lbl.Text = Common.DateWOCentury(values(i))
				End If
			Case 3
				If Main.TimeFormat = 12 Then
					Dim strRet() As String = Common.TimeIn12(values(i))
					lbl.Text = strRet(0) & strRet(1).ToLowerCase
				Else If values(i).StartsWith("0") Then
					lbl.Text = values(i).substring(1)
				Else
					lbl.Text = values(i)
				End If
			Case 4 
				lbl.Text = values(i+2)
			Case 5 
				Dim Value As String = values(i+2)
				' Get the first time for multiline notes
				Dim intPos As Int = Value.IndexOf(CRLF)	' check for multilines text
				If intPos = -1 Then
					lbl.Text = " " & Value
				Else
					' label always multiline!
					lbl.Text = " " & Value.SubString2(0,intPos)	' display only the first line
				End If
				lbl.Gravity = Gravity.LEFT+ Gravity.CENTER_VERTICAL
		End Select
		rc.col = i - 2
		If i = 2 OR i = 3 Then
			lbl.Tag = values(i)			' save the original date & time format!
		Else
			lbl.Tag = rc
		End If
	
		scvSchedule.Panel.AddView(lbl, colOffset(rc.col), NumberOfRows0 * rowHeight , colWidth(rc.col)-1dip, rowHeight-1dip)
	Next
	
	' Exception
	Dim rcx As RowCol			' don't reuse the rc & lbl
	Dim chkBox As CheckBox
	chkBox.Initialize("cell")
	chkBox.Checked = False
	chkBox.Gravity = Gravity.CENTER_HORIZONTAL + Gravity.CENTER_VERTICAL
	rcx.Row = NumberOfRows0
	rcx.col = 4
	chkBox.Tag = rcx
	'chkBox.TextSize = TextSizeStd1
	chkBox.TextColor = Colors.green
	chkBox.Color = Colors.ARGB(255,241,239,150) 
		
	scvSchedule.Panel.AddView(chkBox, colOffset(rcx.col), NumberOfRows0 * rowHeight , colWidth(rcx.col)-1dip, rowHeight-1dip)
	
	NumberOfRows0 = NumberOfRows0 + 1
	
End Sub

Sub LinkToDone
	
	For i = 0 To NumberOfRows0 - 1
		Dim chkBox As CheckBox
		chkBox.Initialize("")
		chkBox = scvSchedule.Panel.GetView(i*NumberOfColumns+4)
		Dim Checked As Int
		Checked = SearchDone(i)
		If Checked = -1 Then
			chkBox.Checked = False
		Else
			chkBox.Checked = True
		End If
	Next
	
End Sub

Sub cell_Click
	Dim x As Object
	x = Sender
	If x Is CheckBox Then
		Dim chkBox As CheckBox
		chkBox.Initialize("")
		chkBox = Sender
		Dim rc As RowCol = chkBox.tag
		'Log("Click rc: " & rc.row & " " & rc.Col)
		'Dim row As Int = rc.row
		If rc.col = 4 Then
			If chkBox.Checked Then
				Dim row() As String = GetValuesDone(rc.row)
				TimeManager.ListScheduleDone.Add(row)
				' for Pending Task, make it enable.
				' so that it will be rolled over.
				SearchTask(row)
				
			Else
				Dim intPos As Int = SearchDone(rc.row)
'				Log("cell_Click: " & intPos)
				TimeManager.ListScheduleDone.RemoveAt(intPos)
			End If 
			SaveDone
		End If
	End If	
End Sub

Sub cell_LongClick
	Dim x As Object
	x = Sender
	If x Is Label Then
		Dim lbl As Label
		lbl.Initialize("")
		lbl = Sender
		If lbl.Tag Is RowCol Then
			Dim rc As RowCol = lbl.tag
'			Log("cell_LongClick rc: " & rc.Row & " " & rc.Col)
			If rc.col = 3 Then
				Dim  values() As String = GetValuesDone(rc.row)
'				Log("cell_LongClick: " & values(0) & " " & values(1)& " " & values(2))
				Dim Notes As String = SearchSchedule(values)
				myMsgBox("N o t e s", HTMLformat(Notes), 1)
			End If
		End If
	End If
End Sub

Sub GetValuesDone(intRow As Int) As String()
	
	Dim Strings(3) As String
	Dim Label As Label
	Label.Initialize("")
	For i = 0 To 1
		Label = scvSchedule.Panel.GetView(intRow*NumberOfColumns+i)
		Strings(i) = Label.tag
	Next
	' skip the group (i = 2)
	Label = scvSchedule.Panel.GetView(intRow*NumberOfColumns+3)
	Strings(2) = Label.Text.trim
	
	Return Strings
	
End Sub

Sub SearchDone(intRow As Int) As Int

	Dim Values(3) As String = GetValuesDone(intRow)
	' searching	
	Dim intPos As Int = -1
	Dim ValuesDone() As String
	For i = 0 To TimeManager.ListScheduleDone.Size - 1
		ValuesDone = TimeManager.ListScheduleDone.Get(i)
'		Log("SearchDone: " & ValuesDone(0) & " " & ValuesDone(1)& " " & ValuesDone(2))
		If ValuesDone(0) = Values(0) AND ValuesDone(1) = Values(1) AND ValuesDone(2).StartsWith(Values(2)) Then
			intPos = i
			Exit
		End If
	Next
	
	Return intPos
	
End Sub

Sub SearchSchedule(values() As String) As String

	' searching	
	Dim Notes As String
	Dim ValuesSchedule() As String
	For i = 0 To TimeManager.ListSchedule.Size - 1
		ValuesSchedule = TimeManager.ListSchedule.Get(i)
		If ValuesSchedule(2) = values(0) AND ValuesSchedule(3) = values(1) AND ValuesSchedule(Main.colNotes).StartsWith(values(2)) Then
			Notes = ValuesSchedule(Main.colNotes)
			Exit
		End If
	Next
	
	Return Notes
	
End Sub

Sub SearchTask(values() As String)

	'Log("SearchTask: " & values(0) & " " &  values(1) & " " &  values(2))
	' searching	
	Dim blnUpdate As Boolean = False
	Dim ValuesTask() As String
	For i = 0 To TimeManager.ListTask.Size - 1
		ValuesTask = TimeManager.ListTask.Get(i)
		If ValuesTask(0) = "D" Then
			'Log("SearchTask: " & ValuesTask(0) & " " &  ValuesTask(1) & " " &  ValuesTask(2))
			If ValuesTask(2) = values(0) AND ValuesTask(3) = values(1) AND ValuesTask(Main.colNotes).StartsWith(values(2)) Then
				If ValuesTask(4) = 1 Then
					ValuesTask(1) = 0	' disable when not recurrent
				Else
					ValuesTask(1) = 1	' enable when recurrent for midnight processing
				End If
				blnUpdate = True
				Exit
			End If
		End If
	Next

	If blnUpdate Then
		TimeManager.ListTask.RemoveAt(i)
		TimeManager.ListTask.Add(ValuesTask)
		
		If TimeManager.ListTask.size > 0 Then
			CallSub(TimeManager,"ListTask_sort")
			StringUtils1.SaveCSV(Main.Dir, Main.FileTask, ",", TimeManager.ListTask)
		Else
			File.Delete(Main.Dir, Main.FileTask)
		End If
		
		StartServiceAt(TimeManager,DateTime.now, True)
	End If
	
End Sub

Sub SaveDone
	' SaveTableToCSV
	If TimeManager.ListScheduleDone.size > 0 Then
		StringUtils1.SaveCSV(Main.Dir, Main.FileDone, ",", TimeManager.ListScheduleDone)
	Else
		File.Delete(Main.Dir, Main.FileDone)
	End If
		
End Sub

#End Region

Sub HTMLformat(text As String) As String
	' make the first line bold
	Dim NewText As String
	Dim intPos As Int = text.IndexOf(CRLF)	' check for multilines text
	If intPos = -1 Then
		NewText= "<b>" & text & "</b>"
	Else
		' label always multiline!
		NewText = "<b>" & text.SubString2(0,intPos) & "</b><BR>"
		NewText = NewText & text.SubString2(intPos+1,text.Length)
	End If
	NewText = NewText.Replace(CRLF, "<BR>")
	Dim HTMLtext As String = "<center>" & NewText & "<center>"
	Return HTMLtext
End Sub

Sub myMsgBox(Title As String, Text As String, Button As Int)
	mMsgBox.NoButton = Button
	mMsgBox.Title = Title
	mMsgBox.Default = Text
	mMsgBox.AddView(Activity, 10%x, 20%y, 80%x, 30%y, 3)
	mMsgBox.Show
End Sub

Sub Msgbox_Closed(Cancelled As Boolean, Selection As String)
	' nothing to do
End Sub

