﻿Type=StaticCode
Version=2.71
@EndOfDesignText@
'Code module
'Subs in this code module will be accessible from all modules.
Sub Process_Globals
	'These global variables will be declared once when the application starts.
	'These variables can be accessed from all modules.
	Dim DBFileName As String = "AlarmSortTmp.db"
	Dim DBFilePath As String = File.DirDefaultExternal
	Dim DBTableName As String = "ScheduleSort"
	
	Dim SQL1 As SQL
	
	Dim NumberOfColumns As Int = 2
	Dim ColumnName(NumberOfColumns) As String
	Dim ColumnType(NumberOfColumns) As String
	
End Sub

'Initializes the object. You can add parameters to this method if needed.
Public Sub Initialize(Source As List)
	File.Delete(DBFilePath, DBFileName)
	If File.Exists(DBFilePath, DBFileName) = False Then
		'If FirstTime Then 
			SQLTableInit
			SQL1.Initialize(DBFilePath, DBFileName, True)
			SQLTableCreate
			SQLTableFill(Source) 
		'End If
	Else
		'If FirstTime Then 
			SQL1.Initialize(DBFilePath, DBFileName, True)
		'End If
	End If
End Sub

Sub SQLTableInit

	ColumnName(0) = "DateHour"
	ColumnName(1) = "Seq"
	
	ColumnType(0) = "INTEGER"	' Don't change to "TEXT"
	ColumnType(1) = "INTEGER"
	
End Sub

Sub SQLTableCreate

	Dim i As Int
	Dim txt As String
	
	SQL1.ExecNonQuery("DROP TABLE IF EXISTS "&DBTableName)
	
	txt = "CREATE TABLE "&DBTableName&" ("&ColumnName(0)&" "&ColumnType(0)
	For i = 1 To NumberOfColumns - 1
		txt = txt&" , "&ColumnName(i)&" "&ColumnType(i)
	Next
	txt = txt&")"
	SQL1.ExecNonQuery(txt)
	
End Sub

Sub SQLTableFill(Source As List)
 	' Fills a SQL data base
	Dim i As Int
	Dim txt1 As String
	
	SQL1.BeginTransaction
	Try
		For i = 0 To Source.size - 1
			Dim values() As String = Source.Get(i)
			txt1 = "INSERT INTO "&DBTableName&" VALUES (" & "'" & values(0) & "'"
			For j = 1 To NumberOfColumns - 1
				txt1 = txt1 & ", '" & values(j) & "'"
			Next
			txt1 = txt1 & ")"
			SQL1.ExecNonQuery(txt1)
		Next
		SQL1.TransactionSuccessful
	Catch
		Log(LastException.Message)
	End Try
	SQL1.EndTransaction
End Sub

Sub SQLTableSort As List
 	' Get from a SQL data base
	Dim Result As List
	Result.Initialize
	
	Dim txt As String
	
	txt = "select * from " & DBTableName & " order by DateHour"
	
	Dim Cursor1 As Cursor

	Cursor1 = SQL1.ExecQuery(txt)

	Dim Col(NumberOfColumns) As String
	
	For i = 0 To Cursor1.RowCount - 1
		Dim Col(NumberOfColumns) As String
		Cursor1.Position = i
		For j = 0 To NumberOfColumns - 1
			Col(j) = Cursor1.GetString(ColumnName(j))
		Next
		Result.Add(Col)
	Next
	Cursor1.Close
		
	Return Result
	
End Sub