﻿Type=Service
Version=2.71
@EndOfDesignText@
#Region  Service Attributes 
	#StartAtBoot: false
	#StartCommandReturnValue: android.app.Service.START_STICKY
#End Region

Sub Process_Globals
	'These global variables will be declared once when the application starts.
	'These variables can be accessed from all modules.
	
	' This service is made START_STICKY -> open "Service Attibutes" above
	
	Dim FileTmp As String = "/tmp.csv"
	
	Dim TimerMidnight As Timer
	Dim DateLastCheck As Long = 0
	
	Dim noti As Notification
	Dim DateTimeTicks As Long
	
	Dim date As String
	Dim time As String
	'Dim dayweek0 As String
	Dim dayweek1 As String

	Dim Dategenerated As Int
	Dim Interval As String = "8h2"
	Dim Group As Int
		
	Dim notes As String = "No alarm is set" & CRLF & "Use Menu - Task Setup"
	Dim Vibrate As Int = 300			' in milisec
	Dim SoundDuration As Int = 1800		' in second
	Dim SoundType As String = "Music"
	Dim AlarmSound As String = ""
	Dim MaxVolume As Int = 65			' in percent
	Dim TimeMaxVolume As Int = 60		' in second
	Dim Snoozes As Int = 3
	Dim TimeBetweenSnoozes As Int = 600 ' in second
					
	Dim ListTask As List
	Dim ListSchedule As List
	Dim ListScheduleSkip As List
	Dim ListScheduleDone As List
	
	Private StringUtils1 As StringUtils
	
End Sub

Sub Service_Create
	
End Sub

Sub Service_Start (StartingIntent As Intent)
	' don't use 30 * DateTime.TicksPerMinute???
	TimerMidnight.Initialize("TimerMidnight", 30 * 60 * 1000)
	TimerMidnight.Enabled = True

	PrepareData
	Select_Next
End Sub

Sub Service_Destroy
	
End Sub

Sub PrepareData
	ReadData
	ExpandData
End Sub

Sub ReadData
	
'	Log("ReadData")
	DateTime.DateFormat = "MM/dd/yyyy"
	
	ListTask.Initialize
	If File.Exists(Main.dir, Main.FileTask) Then
		ListTask = StringUtils1.LoadCSV(Main.dir, Main.FileTask, ",")
	End If
		
	' Move to Midnight check
'	If DateTime.date(DateLastCheck) <> DateTime.date(DateTime.Now) Then
'		ListTask_check
'		DateLastCheck = DateTime.Now
'		Log("DateLastCheck: " & DateTime.date(DateLastCheck))
'	End If
	
	ListScheduleSkip.Initialize
	If File.Exists(Main.dir, Main.fileSkip) Then
		ListScheduleSkip = StringUtils1.LoadCSV(Main.dir, Main.fileSkip, ",")
	End If
	
	' Cleaning the ListScheduleSkip from outdated data
	If ListScheduleSkip.Size > 0 Then
		Dim ValuesSkip() As String
		For i = ListScheduleSkip.Size - 1 To 0 Step -1
			ValuesSkip = ListScheduleSkip.Get(i)
			If DateTime.DateTimeParse(ValuesSkip(0), ValuesSkip(1) & ":00") < DateTime.Now Then
				ListScheduleSkip.RemoveAt(i)
			End If
		Next
		If ListScheduleSkip.Size > 0 Then
			' save the clean data
			StringUtils1.SaveCSV(Main.Dir, Main.FileSkip, ",", ListScheduleSkip)
		Else
			File.Delete(Main.Dir, Main.FileSkip)
		End If
	End If
	
	ListScheduleDone.Initialize
	If File.Exists(Main.dir, Main.fileDone) Then
		ListScheduleDone = StringUtils1.LoadCSV(Main.dir, Main.fileDone, ",")
	End If
	
End Sub

Sub ExpandData
'   Log(DateTime.DeviceDefaultTimeFormat)
'	Dim x As String = DateTime.DeviceDefaultDateFormat
'	Log(x)
' 	DateTime.DateFormat = "MM/dd/yyyy"
'	datetime.TimeFormat = "HH:mm"
'	Dim t As Long
'	t = DateTime.DateParse("16-05-2011")
'	DateTime.DateFormat = "yyyy-MM-dd HH:mm"
'	Dim s As String
'	s = DateTime.Date(t)

'	 Log("ExpandData")
		
	' Filter
	Dim listscheduleTmp As List
	listscheduleTmp.Initialize
	Dim row() As String
	For i = 0 To ListTask.Size -1
		row = ListTask.get(i)
		If row(1) > 0 Then
			listscheduleTmp.Add(row)
		End If
	Next 
	
	DateTime.DateFormat = "MM/dd/yyyy"	' Don't forget
	
	' Convert from DayOfWeek to Date
	'Log("ListscheduleTmp Size: " & listscheduleTmp.Size)
	ListSchedule.Initialize
	For i = 0 To listscheduleTmp.Size -1
		row = listscheduleTmp.get(i)
		'Log("ListSchedule Date:" & row.get(2) & " " & row.get(3))
		Select Case row(0) 
			Case "W"  
				' parsing the to Days
				Dim dateCreate As List 
				dateCreate.Initialize
				dateCreate = ParsingDOW(row(2), row(4))
				Dim rowx() As String
				For j = 0 To dateCreate.Size - 1
					' note the row can not add directly
					' ListSchedule.Add(row) -> error/warning
					rowx = CopyArray(row)
					rowx(2) = DateTime.date(dateCreate.get(j))
					ListSchedule.Add(rowx)
				Next
			Case "D" 
				ListSchedule.Add(row)
				'Log(row(0) & " " & row(1) & " " & row(2) & " " & row(3))
			Case "I"
				' parsing the to Days
				Dim dateCreate As List 
				dateCreate.Initialize
				dateCreate = ParsingInterval(DateTime.DateTimeParse(row(2), row(3) & ":00"), row(4), row(5))
				Dim rowx() As String
				For j = 0 To dateCreate.Size - 1
					' note the row can not add directly
					' ListSchedule.Add(row) -> error/warning
					rowx = CopyArray(row)
					rowx(2) = DateTime.date(dateCreate.get(j))
					rowx(3) = DateTime.time(dateCreate.get(j))
					rowx(3) = rowx(3).SubString2(0,5)
					'Log("Interval: " & rowx(2)& " " & rowx(3))
					ListSchedule.Add(rowx)
				Next
		End Select
	Next
	
'	Log("Listschedule Size: " & ListSchedule.Size)
	
	Dim ValuesSkip() As String
	For i = 0 To ListSchedule.Size - 1
		row = ListSchedule.get(i)
		For j = 0 To ListScheduleSkip.Size -1
			ValuesSkip = ListScheduleSkip.Get(j)
			If row(2) = ValuesSkip(0) AND row(3) = ValuesSkip(1) AND  row(Main.colNotes).StartsWith(ValuesSkip(2)) Then
				row(1) = 0
				ListSchedule.RemoveAt(i)
				ListSchedule.InsertAt(i, row)
			End If	
		Next 
	Next
	
	' Sort by Date and Time
	' list.sort can NOT be use for datatype long (dateticks)
	' the easiest is using SQLite
	' the notes can not include in the sort if there is a single quotation mark.
	ListSchedule_sort
	
End Sub

Sub Select_Next

	' Select the nearest alarm	
	AlarmService.SnoozeCount = 0
	DateTime.dateformat = "MM/dd/yyyy"
	Dim row() As String
	For i = 0 To ListSchedule.Size - 1
		row = ListSchedule.get(i)
		'Log("select_next: " & row(2) & " " & row(3))
		If DateTime.DateTimeParse(row(2),row(3) & ":00") > DateTime.Now Then
			'Log("select_next: " & row(2) & " " & row(3))
			If row(1) > 0 Then
				Save2Parameter(row)
			
				SetTime
				Alarm_Set
				
				' This following data is neede only if the application is killed
				SaveData(row)
				
				Exit
			End If
		End If
	Next
	
	If i = ListSchedule.Size Then
		' No pending alarm found
		'Log("No Alarm")
		DateTimeTicks = 0
		notes = "No alarm is set" & CRLF & "Use Menu - Task Setup"
		StopService("AlarmService")     'Stop this service
		CancelScheduledService("AlarmService")   'Cancel this service
	End If
	
End Sub

Sub Save2Parameter(row() As String)

	date = row(2)
	If row(3).StartsWith("0") Then
		time = row(3).SubString(1)	' don't want to show the prefix 0 of hour
	Else
		time = row(3)
	End If
	Dategenerated = row(4)
	Interval = row(5)
	Group = row(6)
	notes = row(7)
	Vibrate = row(8)
	SoundDuration = row(9)
	SoundType = row(10)
	AlarmSound = row(11)
	MaxVolume  = row(12)
	TimeMaxVolume  = row(13)	' in second
	Snoozes = row(14)
	TimeBetweenSnoozes = row(15) ' in second
	
End Sub

Sub SaveData(row() As String)
	Dim ListTmp As List
	ListTmp.Initialize
	ListTmp.Add(row)
	StringUtils1.SaveCSV(Main.dir, FileTmp, ",", ListTmp)

End Sub

Sub RecallData
	Dim ListTmp As List
	ListTmp.Initialize
	ListTmp = StringUtils1.LoadCSV(Main.dir, FileTmp, ",")
	Dim row() As String
	row = ListTmp.Get(0)
	
	Save2Parameter(row)
	
	SetTime
	
End Sub

Sub SetTime
	
	DateTimeTicks = DateTime.DatetimeParse(date,time & ":00")
	'dayweek0 = Common.DayOfWeek(DateTimeTicks,True)
	dayweek1 = Common.DayOfWeek(DateTimeTicks,False)
	
End Sub

Sub CompareSnoozeWithSchedule
	Dim DateTimeSchedule As Long
	
	DateTime.dateformat = "MM/dd/yyyy"
	Dim row() As String
	For i = 0 To ListSchedule.Size - 1
		row = ListSchedule.get(i)
		If DateTime.DateTimeParse(row(2),row(3) & ":00") > DateTime.Now Then
			If row(1) > 0 Then
				DateTimeSchedule = DateTime.DatetimeParse(row(2), row(3) & ":00")
				Exit
			End If
		End If
	Next
	
	If DateTimeTicks > DateTimeSchedule Then
		Select_Next
	End If
	
	Alarm_Set
	
End Sub

Sub Alarm_Set

	StartServiceAt(AlarmService, DateTimeTicks, True)		
	Log("Alarm_Set: " & DateTime.date(DateTimeTicks) & " " & DateTime.time(DateTimeTicks))
		
	noti.Initialize
	noti.Light = False
	noti.Vibrate = False
	noti.OnGoingEvent = True
	noti.Sound = False
	noti.icon = "bell" ' file name should in lower case, read only attribute
	Dim rtrimTime As String = DateTime.time(DateTimeTicks).SubString2(0,5)
	DateTime.DateFormat = "dd MMM yyyy"
	noti.SetInfo("NotiBell reminder", "Set at " & Common.DayOfWeek(DateTimeTicks,True) & " " & DateTime.date(DateTimeTicks) & " " & rtrimTime, "RingAction")
	DateTime.DateFormat = "MM/dd/yyyy"
	noti.Notify(1)
	
	CallSub(Main, "Refresh")
	
End Sub

Sub ParsingDOW(BitwiseDOWeek As Int, Days As Int) As List
	
	Dim DOWeek As List
	DOWeek.Initialize
	DOWeek = Common.WeekOfDayGet(BitwiseDOWeek)
	Dim DateCreate As List
	DateCreate.Initialize
	Dim dateY As Long
	For i = 0 To Days - 1	' look at the next Repeat days including today.
		dateY = DateTime.Add(DateTime.Now,0,0,i)
		For j = 0 To DOWeek.Size - 1
			If DateTime.GetDayOfWeek(dateY) = DOWeek.Get(j) Then
				DateCreate.Add(dateY)
			End If
		Next 
	Next
	
	Return DateCreate
	
End Sub

Sub ParsingInterval(lngDate As Long, NoOfDays As Int, MinxTimes As String) As List
	
	Dim DateCreate As List
	DateCreate.Initialize
	Dim intRepeat As Int
	Dim intMinutes As Int
	Dim intPos As Int
	intPos = MinxTimes.IndexOf("h")
	If intPos = -1 Then
		intPos = MinxTimes.IndexOf("m")
	End If
	If intPos = -1 Then
		intPos = MinxTimes.IndexOf("d")
	End If
	If intPos > 0 Then
		intRepeat = MinxTimes.SubString(intPos+1)
		intMinutes = MinxTimes.SubString2(0,intPos)
		'Log("ParsingInterval: " & intRepeat & " " & intMinutes)
		If MinxTimes.Contains("h") Then
			intMinutes = intMinutes * 60
		Else If MinxTimes.Contains("d") Then
			intMinutes = intMinutes * 24 * 60
		End If
	
		Dim dateY As Long
		For i = 0 To NoOfDays - 1	' for NoOfDays days from the StartDate
			dateY = DateTime.Add(lngDate,0,0,i)
			DateCreate.Add(dateY)
			For j = 0 To intRepeat - 1
				dateY = dateY + intMinutes * DateTime.TicksPerMinute
				DateCreate.Add(dateY)
			Next
		Next
	End If
	
	Return DateCreate
	
End Sub

Sub CopyArray(row() As String) As String()
	Dim NewRow(row.Length) As String
	For i = 0 To row.Length - 1
		NewRow(i) = row(i)
	Next
	
	Return NewRow
	
End Sub

#Region  Sort 

Sub ListSchedule_sort
	'Add a row number to the ListSchedule
	Dim ListScheduleTmp As List
	ListScheduleTmp.Initialize
	Dim row() As String
	For i = 0 To ListSchedule.Size - 1
		row = ListSchedule.get(i)
		ListScheduleTmp.Add(row)
	Next
	
	Dim ListDateHour As List
	ListDateHour.Initialize
	For i = 0 To ListScheduleTmp.Size - 1
		row = ListSchedule.get(i)
		ListDateHour.Add(Array As String(DateTime.DateTimeParse(row(2), row(3) & ":00"), i))
	Next
	
	Try
		SQL_sort.Initialize(ListDateHour)
		ListDateHour = SQL_sort.SQLTableSort
	Catch
		ToastMessageShow("Failed in SQL sorting",True)
	End Try
	
	ListSchedule.Clear
	Dim rowList() As String
	For i = 0 To ListDateHour.Size - 1
		row = ListDateHour.get(i)
		'Log(row(0) & " " & row(1))
		rowList = ListScheduleTmp.Get(row(1))
		'Log(rowList(2) & " " & rowList(3))
		ListSchedule.add(rowList)
	Next
	
End Sub

Sub ListTask_sort
	'Add a row number to the ListTask
	Dim ListTaskTmp As List
	ListTaskTmp.Initialize
	
	Dim row() As String
	For i = 0 To ListTask.Size - 1
		row = ListTask.get(i)
		ListTaskTmp.Add(row)
	Next

	Dim ListDateHour As List
	ListDateHour.Initialize
	For i = 0 To ListTaskTmp.Size - 1
		row = ListTaskTmp.get(i)
		If row(0) = "W" Then
			' Beware don't use "01/01/2000" if converted to string!!!
			' Log(DateTime.dateparse("01/01/2000")) "946659600000"
			' Log(DateTime.dateparse("01/01/2013")) "1356973200000"
			ListDateHour.Add(Array As String(DateTime.DateTimeParse("01/01/2000", row(3) & ":00"), i))
		Else
			ListDateHour.Add(Array As String(DateTime.DateTimeParse(row(2), row(3) & ":00"), i))
		End If
	Next
	
	Try
		SQL_sort.Initialize(ListDateHour)
		ListDateHour = SQL_sort.SQLTableSort
	Catch
		ToastMessageShow("Failed in SQL sorting",True)
	End Try
	
	ListTask.Clear
	Dim rowList() As String
	For i = 0 To ListDateHour.Size - 1
		row = ListDateHour.get(i)
		rowList = ListTaskTmp.Get(row(1))
		'Log(rowList(2) & " " & rowList(3))
		ListTask.add(rowList)
	Next
	
End Sub

#End Region

#Region  Midnight Updating 

Sub TimerMidnight_tick

	If DateTime.date(DateLastCheck) <> DateTime.date(DateTime.Now) Then
		'Log("DateLastCheck: " & DateTime.date(DateLastCheck))
		' Just to make sure it is the lastest data
		ListTask.Initialize
		If File.Exists(Main.dir, Main.FileTask) Then
			ListTask = StringUtils1.LoadCSV(Main.dir, Main.FileTask, ",")
		End If
		
		ListScheduleDone_check
		
		ListTask_check
		
		DateLastCheck = DateTime.Now
		
		PrepareData
		Select_Next
	End If

End Sub

Sub ListTask_check

	'Updating the Interval (roll over)
	Dim values() As String 
	Dim blnUpdate As Boolean = False
	For i = 0 To ListTask.Size - 1
		values = ListTask.Get(i)
		Dim dateStart As Long
		Dim intHours As Int
		'Log("ListTask_check: " & values(0) & " " & values(1) & " " & values(2) & " " & values(3))
		If values(0) = "I" AND values(1) = 1 Then
			' check if it is expired
			dateStart = DateTime.DateTimeParse(values(2), values(3)& ":00")
			intHours = Common.Intxtimes_hour(values(5))
			Dim blnUpdateSub As Boolean = False
			If intHours <= 24 Then
				If DateTicks(DateTime.Add(dateStart,0,0,values(4))) <= DateTicks(DateTime.Now) Then
					blnUpdateSub = True
				End If
			Else
				If DateTicks(dateStart + intHours * DateTime.TicksPerHour) <= DateTicks(DateTime.Now) Then
					blnUpdateSub = True
				End If
			End If
			If blnUpdateSub Then
				dateStart = DateTime.now
				values(2) = DateTime.date(DateTime.now)
				ListTask.RemoveAt(i)
				ListTask.InsertAt(i,values)
				blnUpdate = True
			End If
		Else If values(0) = "D" AND values(1) = 1 AND values(4) > 1 Then
			'Log("ListTask_check: " & values(0) & " " & values(1) & " " & values(2) & " " & values(3) & " " & values(4))
			dateStart = DateTime.DateTimeParse(values(2), values(3)& ":00")
			Dim NewDate As Long
			If DateTicks(DateTime.Add(dateStart,0,0,1)) <= DateTicks(DateTime.Now) Then
				Select Case values(4) 
					Case 30 
						If DateTime.GetMonth(dateStart) = 12 Then
							NewDate = DateUtils.SetDate(DateTime.GetYear(dateStart)+1, 1, DateTime.GetDayOfMonth(dateStart))
						Else
							NewDate = DateUtils.SetDate(DateTime.GetYear(dateStart),DateTime.GetMonth(dateStart) + 1, DateTime.GetDayOfMonth(dateStart))
						End If
					Case 360 
						NewDate = DateUtils.SetDate(DateTime.GetYear(dateStart)+1,DateTime.GetMonth(dateStart), DateTime.GetDayOfMonth(dateStart))
				End Select
				values(2) = DateTime.date(NewDate)
				ListTask.RemoveAt(i)
				ListTask.InsertAt(i,values)
				blnUpdate = True
			End If
		End If
	Next
	
	If blnUpdate Then
		ListTask_sort
		StringUtils1.SaveCSV(Main.Dir, Main.FileTask, ",", ListTask)
	End If
	
End Sub

Sub ListScheduleDone_check

	ListScheduleDone.Initialize
	If File.Exists(Main.dir, Main.fileDone) Then
		ListScheduleDone = StringUtils1.LoadCSV(Main.dir, Main.fileDone, ",")
	End If
	'Log ("ListScheduleDone_check")
	If ListScheduleDone.Size > 0 Then
		Dim ValuesSkip() As String
		For i = ListScheduleDone.Size - 1 To 0 Step -1
			ValuesSkip = ListScheduleDone.Get(i)
			If DateTime.DateParse(ValuesSkip(0)) < DateTicks(DateTime.Now) Then
				ListScheduleDone.RemoveAt(i)
			End If
		Next
		If ListScheduleDone.Size > 0 Then
			' save the clean data
			StringUtils1.SaveCSV(Main.Dir, Main.FileDone, ",", ListScheduleDone)
		Else
			File.Delete(Main.Dir, Main.FileDone)
		End If
	End If
	
End Sub

Sub DateTicks(value As Long) As Long
	' get the date only without time
	DateTime.DateFormat = "MM/dd/yyyy"
	Return DateTime.DateParse(DateTime.date(value))
	
End Sub


#End Region

